



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>linux --- Ansible篇</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">linux --- Ansible篇</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 07:19:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>ansible背景</h2>
<h3>1.什么是ansible?</h3>
<p>ansible是新出现的自动化运维工具，基于Python开发，集合了众多运维工具（puppet、cfengine、chef、func、fabric）的优点，实现了批量系统配置、批量程序部署、批量运行命令等功能。</p>
<h3>2.ansible的是怎么工作的?</h3>
<div>ansible是基于模块工作的，本身没有批量部署的能力。真正具有批量部署的是ansible所运行的模块，ansible只是提供一种框架。主要包括：</div>
<div>(1)、连接插件connection plugins：负责和被监控端实现通信；</div>
<div>(2)、host inventory：指定操作的主机，是一个配置文件里面定义监控的主机；</div>
<div>(3)、各种模块核心模块、command模块、自定义模块；</div>
<div>(4)、借助于插件完成记录日志邮件等功能；</div>
<div>(5)、playbook：剧本执行多个任务时，非必需可以让节点一次性运行多个任务。</div>
<h2>ansible基础</h2>
<h3>1.ansible安装</h3>
<div>
<pre class="prettyprint linenums">yum install wget -y     #安装wget<br />
wget -O /etc/yum.repos.d/epel.repo http://mirrors.aliyun.com/repo/epel-7.repo  #下载epel源文件

yum install ansible -y    #安装ansible</pre>
</div>
<h3>2.ansible的命令格式</h3>
<div>
<pre class="prettyprint linenums">-a MODULE_ARGS, --args=MODULE_ARGS  #模块参数

-C, --check     #白跑一次,不做任何改变

-f FORKS, --forks=FORKS   #指定进程数,做并发用

 --list-hosts  #列出主机

-m MODULE_NAME #模块名称

 --syntax-check  #检查语法

 -k, --ask-pass  ask for connection password   #指定密码</pre>
</div>
<h3>3.查看ansible生成的配置文件</h3>
<div>
<pre class="prettyprint linenums"> rpm -ql ansible  </pre>
</div>
<p>配置hosts文件,比如我有四台机器 ip段 192.168.220.133/134/135/136,此时安装ansible机器为192.168.220.133,以下配置</p>
<div>
<pre class="prettyprint linenums">vi /etc/ansible/hosts <br />
192.168.220.134<br />
192.168.220.135<br />
192.168.220.136

#将这3个机器ip写入hosts文件中</pre>
</div>
<h3>4.ansible如何通过ssh与远程服务器连接?</h3>
<p>第一种: 密码&nbsp; &nbsp; ssh root@192.168.220.133 --&gt;输入root密码即可</p>
<p>第二种:秘钥 (推荐)</p>
<ul><li>ssh -keygen&nbsp; #生成秘钥</li>
<li>ssh-copy-id root@192.168.220.134&nbsp; #将秘钥文件复制到远程主机</li></ul>
<p>当通过ansible控制量级比较大的机器的时候,使用秘钥连接的方法最为快捷方便</p>
<h3>5.ansible的第一个命令ping</h3>
<h4>ping走的是icmp协议</h4>
<p>ansible 192.168.220.134 -m ping</p>
<div>
<pre class="prettyprint linenums">#反馈如下便能建立连接

192.168.220.134 | SUCCESS =&gt; {<br />
    "changed": false,<br />
    "ping": "pong"<br />
}</pre>
</div>
<p>以此类推 ...</p>
<p>　　ansible 192.168.220.135 -m ping</p>
<p>　　ansible 192.168.220.136 -m ping</p>
<p>　　ansible all -m ping&nbsp; ---&gt;所有机器,hosts文件</p>
<p>　　ansible 192.168.220.135,192.168.220.136 -m ping&nbsp; &nbsp;---&gt;探测部分机器</p>
<h3>6.ansible分组查看机器</h3>
<div>
<pre class="prettyprint linenums">#在hosts文件中写入以下配置

[web]<br />
192.168.220.134<br />
192.168.220.135

[cache]<br />
192.168.220.135<br />
192.168.220.136

[db]<br />
192.168.220.134<br />
192.168.220.135<br />
192.168.220.136</pre>
</div>
<p>ansible web --list-hosts&nbsp; &nbsp; &nbsp;#用来获取符合条件的主机</p>
<div>
<pre class="prettyprint linenums">#反馈情况为:<br />
[root@localhost ~]# ansible web --list-hosts<br />
  hosts (2):<br />
    192.168.220.135<br />
    192.168.220.134</pre>
</div>
<p>ansible web -m ping&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#探测web组内的所有机器</p>
<h4>ansible分组并集</h4>
<p>　　ansible web,cache -m ping&nbsp; &nbsp; #探测web,cache两个组的并集机器</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# ansible web,cache,db -m ping<br />
192.168.220.135 | SUCCESS =&gt; {<br />
    "changed": false,<br />
    "ping": "pong"<br />
}<br />
192.168.220.134 | SUCCESS =&gt; {<br />
    "changed": false,<br />
    "ping": "pong"<br />
}<br />
192.168.220.136 | SUCCESS =&gt; {<br />
    "changed": false,<br />
    "ping": "pong"<br />
}<br />
#两者组内所有</pre>
</div>
<h4>ansible分组交集</h4>
<ul><li>ansible 'web:cache' -m ping&nbsp; #获取web cache两个组交集的机器</li>
<li>ansible 'web:&amp;cache' -m ping&nbsp; #获取web cache两个组交集的机器</li></ul>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# ansible 'web:&amp;cache' -m ping<br />
192.168.220.135 | SUCCESS =&gt; {<br />
    "changed": false,<br />
    "ping": "pong"<br />
}<br />
#两者分组中共有的</pre>
</div>
<h4>ansible分组差集</h4>
<p>　　ansible 'web:!cache' -m ping&nbsp; #获取web cache两个组差集的机器</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# ansible 'web:!cache' -m ping<br />
192.168.220.134 | SUCCESS =&gt; {<br />
    "changed": false,<br />
    "ping": "pong"<br />
}<br />#两者分组中不一样的,表现为前者分组中机器为后者没有,</pre>
</div>
<h3>弱口令校验</h3>
<p>服务器密码符合规则:</p>
<p>必须有大小写字母,数字,特殊字符;</p>
<p>密码必须12位以上;</p>
<p>密码3个月轮换;</p>
<h3>host-pattern的格式</h3>
<ul><li>单个主机</li>
<li>单个组</li>
<li>多个组
<div>
<pre class="prettyprint linenums">#交集   "web:&amp;cache"

#并集   "web:cache"    "web,cache"

#差集   "web:!&amp;cache"</pre>
</div></li>
<li>所有机器&nbsp; all</li>
<li>多个主机</li></ul>
<h2>ansible常用模块</h2>
<h3>获取模块的帮助信息</h3>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# ansible-doc -h   # 显示全部信息<br />
Usage: ansible-doc [-l|-F|-s] [options] [-t &lt;plugin type&gt; ] [plugin]

-j, --json      #以json的方式返回所有模块的信息<br />
-l            # 列出所有的模块<br />
-s, --snippet # 以片段式显示模块的帮助信息

ansible-doc -l |wc -l     #统计ansible的模块 2080</pre>
</div>
<h3>1.command模块</h3>
<p>执行命令,不支持特殊字符,如$ &amp; &lt; &gt; | ;</p>
<div>
<pre class="prettyprint linenums">#参数<br />
chdir   #切换目录 一般编译安装使用

creates   #判断是否存在,如果存在就 不 执行,不存在,就执行

removes  #与creates正好相反

ansible web -m command -a 'pwd'      #执行web组所有机器pwd命令  ,拿到所有机器的 /root    -m表示调用模块, -a 表示参数<br />
ansible web -m command -a "ls /tmp"  #执行web组所有机器查看tmp目录下的文件

ansible web -m command -a "chdir=/tmp pwd" #切换目录到/tmp下,一般编译安装

ansible web -m command -a "creates=/tmp pwd"  #不被执行,直接跳过 ,因为/tmp已存在<br />
ansible web -m command -a  "creates=/tmp2 pwd"  #执行,因为/tmp2不存在<br />
ansible web -m command -a  "creates=/tmp2 mkdir /data" #会被执行,并且创建/data目录,因为/tmp2不存在

ansible web -m command -a "removes=/tmp2 pwd" #不执行,因为tmp2不存在<br />
ansible web -m command -a "removes=/tmp pwd" #执行</pre>
</div>
<p>补充:</p>
<div>
<pre class="prettyprint linenums">#查看用户是否被成功创建<br />
1. ll /home<br />
2. tail -1 /etc/passwd #查看passwd文件(存放密码)最后一行<br />
3. tail  /etc/shadow   #查看shadow(存放用户信息)<br />
4. id coco   #查询指定用户id

#给用户设置密码,不需要二次确认<br />
先创建一个用户 useradd Sheldon<br />
echo "ni666" |passwd --stdin Sheldon  

#单引号和双引号在echo命令的不同<br />
[root@localhost ~]# name=coco<br />
[root@localhost ~]# echo "$name"<br />
coco<br />
[root@localhost ~]# echo '$name'<br />
$coco</pre>
</div>
<h3>2.shell模块</h3>
<p>执行远程机器上的shell脚本或python脚本</p>
<div>
<pre class="prettyprint linenums">ansible web -m shell -a "echo 'coco'|passwd --stdin coco " #给远程机器设置用户密码,前提是远程主机上有coco账户

# shell 脚本<br />
要在文件顶部写上#!/bin/bash<br />
ansible 192.168.220.134 -m  shell -a "bash /data/a.sh" #执行shell a.sh脚本内容,前提是该机器有这个文件,并有内容  

#示例1<br />
ansible 192.168.220.134 -m shell  -a "chmod u+x /data/a.sh"  #先远程将a.sh脚本改成可执行<br />
ansible 192.168.220.134 -m shell  -a "/data/a.sh"  #远程执行脚本

# python脚本

开头写上如下两句<br />
#!/bin/env python<br />
#coding:utf-8

ansible 192.168.220.134 -m shell -a "python /root/b.py"  #调用python解释器运行

ansible 192.168.220.134 -m shell -a " /root/b.py"  #自己将该目录下的b.py权限设置为可执行的即可  chmod u+x /root/b.py</pre>
</div>
<h3>3.script模块</h3>
<p>执行的是管控机/本地的脚本</p>
<div>
<pre class="prettyprint linenums">ansible db -m script -a "python /root/a.py"  #执行的是本地的脚本，管控机上的脚本

ansible db -m script -a "creates=/root/a.py /root/a.sh" # 判断是远程主机是否存在，如果存在，就不执行，如果不存在，就执行<br />
ansible db -m script -a "removes=/root/a.py /root/a.sh" # 判断是远程主机是否存在，如果存在，就不执行，如果不存在，就执行

#以上也就是多了个远程主机的条件,但是执行的是本地的脚本</pre>
</div>
<h3>4.copy模块</h3>
<p>将本地文件复制到远程机上</p>
<div>
<pre class="prettyprint linenums">#参数<br />
backup     #创建备份文件,以时间戳结尾<br />
content    #直接写内容<br />
dest       #目标地址<br />
group      #文件的属组<br />
mode       #文件的权限W２　Ｒ４　　X１<br />
owner      #文件的属主<br />
src        #源文件 

ansible db -m copy  -a "src=/root/a.py dest=/root/a.py" #复制本地文件到远程主机<br />
ansible db -m copy -a "src=/root/a.py dest=/data/a.py mode=755" #复制文件到远程主机指定路径,并且改变文件权限<br />
ansible db -m copy -a "src=/root/a.py dest=/data/a.py mode=755 owner=coco" #复制文件到远程主机指定路径,改变文件权限 属主,根据md5值进行比对,注意coco需要在远程主机建立该用户.

ansible db -m copy -a "src=/etc/init.d dest=/tmp/"　＃复制文件夹<br />
ansible db -m copy -a "src=/etc/init.d/ dest=/tmp/"　＃复制文件夹下面的所有文件<br />
ansible db -m copy -a "src=/etc/init.d dest=/tmp/ owner=coco "　＃复制文件夹，并改变文件夹的属性，文件夹的文件的属性也会跟着改变

ansible  db -m copy -a "content='生活需要勇气' dest=/tmp/a.sh"   #覆盖写入文字,慎用

ansible db -m copy -a "src=/root/a.py dest=/data/a.py mode=755 owner=coco backup=yes"  #注意: 备份文件，如果远程机器上没有要备份的文件，即使指定了backup＝ｙｅｓ也不会去备份文件</pre>
</div>
<h3>5.file模块</h3>
<p>在远程主机上创建文件,文件夹,软连接,硬链接</p>
<div>
<pre class="prettyprint linenums">#参数<br />
access_time   #访问事件<br />
group         #属组<br />
mode          #权限<br />
owner         #属主<br />
path          #路径<br />
src           #原文件,link和hard的时候使用<br />
state:<br />
    directory  文件夹<br />
    file<br />
    touch      空文件<br />
    link       软连接:<br />
    hard       硬链接<br />
    absent     删除

补充:<br />
#软连接:windows的快捷方式 ln -s 原文件 目标文件     源文件改变,目标文件也改变,可以跨越分区,源文件删除,链接失效

#硬链接:指向同一个硬盘的地址 ln 原文件  目标文件    原文件改变,目标文件也改变,不可以跨越分区,原文件删除,不会受影响

#软连接类似于python中的浅拷贝,硬链接则是像极了深拷贝</pre>
</div>
<p>示例</p>
<div>
<pre class="prettyprint linenums">ansible db -m file -a "path=/data/temp state=directory" #在远程机上创建一个目录

ansible db -m file -a "path=/data/task state=directory owner=coco mode=644"  #在远程机上创建一个属主为coco 且权限为drw - r -r 权限的目录

ansible db -m file -a "path=/data/aiqing.txt state=touch owner=coco mode=644" #在远程机上创建一个属主为coco 的文件

ansible db -m file -a "path=/tmp/fffff src=/data/aiqing.txt state=link"  #在远程机创建一个软连接

ansible db -m file -a "path=/tmp/fffff state=absent"  #删除软连接</pre>
</div>
<p>------------ 平常心&nbsp;------------ 面对&nbsp;------------ ALL DIFFICULTIES&nbsp;------------ 勤能补拙,熟能生巧&nbsp;------------</p>
<div>
<div>
<pre class="prettyprint linenums">1- 获取db组/opt目录下文件

2- 创建icon用户，并设置密码为xiaokeai

3- 在/tmp目录下生成aa.txt文件，文件的内容为"大弦嘈嘈如急雨，小弦切切如私语，嘈嘈切切错杂弹，大珠小珠落玉盘"

4- 将本地的网卡配置文件复制到远程机器上，并命名为network，用户为icon，用户组为icon，权限为744

5- 在/opt目录下创建ab.py文件,并指定用户为icon，用户组为icon，权限为744

6- 在/opt目录下创建canglaoshi目录</pre>
</div>
<p>小小练习</p></div>
<div>
<div>
<pre class="prettyprint linenums">1. ansible db -m command -a "ls /opt"

2. [root@localhost ~]# ansible db -m command -a "useradd icon"

[root@localhost ~]# ansible db -m shell -a "echo 'xiaokeai'|passwd --stdin 'icon' "   #由于command模块不支持特殊字符,因此需要shell模块支持

3. [root@localhost ~]# ansible db -m copy -a "content='大弦嘈嘈如急雨，小弦切切如私语，嘈嘈切切错杂弹，大珠小珠落玉盘' dest=/tmp/aa.txt"

4.[root@localhost ~]# ansible db -m copy -a "src=/etc/sysconfig/network-scripts/ifcfg-ens33 dest=/opt/network group=icon owner=icon mode=744"

5. ansible db -m file -a "path=/opt/ab.py state=touch group=icon owner=icon mode=744"

6. ansible db -m file -a "path=/opt/canglaoshi state=directory"</pre>
</div>
<p>小小练习答案</p></div>
<h3>6.fetch模块</h3>
<p>fetch (英&nbsp;/fetʃ/ vt.取来) 将远程主机器上的文件拉取到本地/管控机,以ip或者主机名生成目录,并保留原先目录结构</p>
<div>
<pre class="prettyprint linenums">#fetch ---参数<br />
dest   #目标地址<br />
src     #源地址

ansible web -m fetch -a "dest=/data src=/data/a.py"<br />
#注意拉取远程主机文件的时候如果只获取到目录,无文件无效</pre>
</div>
<h3>7.yum模块</h3>
<h4>① yum与rpm的区别</h4>
<p>　　rpm适用于所有环境，而yum要搭建本地yum源才可以使用;</p>
<p>　　yum是上层管理工具，自动解决依赖关系，而rpm是底层管理工具。</p>
<h4>② yum 源的配置</h4>
<div>
<pre class="prettyprint linenums">#配置信息  /etc/yum.repos.d/epel.repo<br />
[epel]  #名称<br />
name=Extra Packages for Enterprise Linux 7 - $basearch  #描述信息<br />
baseurl=http://mirrors.aliyun.com/epel/7/$basearch      #yum源的地址<br />
failovermethod=priority<br />
enabled=1    #指定yum源是否可用,1表示可用,0则相反<br />
gpgcheck=0   #是否检查gpgkey文件,0表示不检查,1表示检查<br />
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-EPEL-7</pre>
</div>
<h4>③ 包组</h4>
<p>　　linux&nbsp; --&gt; lib&nbsp; &nbsp; &nbsp;| windows ---&gt; dll</p>
<div>
<pre class="prettyprint linenums">yum grouplist  #查看包组

yum groupinstall   #安装包组</pre>
</div>
<h4>④查看包安装状态</h4>
<div>
<pre class="prettyprint linenums">yum list|grep redis     #出现 @ 代表安装成功<br />
rpm -q redis   

rpm -qa   #查看所有安装包<br />
rpm -ql    #查看安装包生成的文件</pre>
</div>
<h4>⑤ 参数以及使用</h4>
<div>
<pre class="prettyprint linenums">#yum 参数<br />
disable_gpg_check     #是否检查key<br />
disablerepo                #禁用repo<br />
name         #包名<br />
state          #状态    installed removed

#注意:在给远程机器安装包组的时候要确保远程机器上有epel.repo 文件<br />
ansible db -m copy -a "src=/etc/yum.repos.d/epel.repo dest=/etc/yum.repos.d/"

ansible web -m yum -a "name=python2-pip"  #安装一个包<br />
ansible web -m yum -a "name='@Development Tools'" # 安装包组<br />
ansible web -m yum -a "name=redis,python2-pip" # 同时安装多个包<br />
ansible web -m yum -a "name=redis state=absent" # 卸载</pre>
</div>
<h3>8.pip模块</h3>
<h4>①pip命令</h4>
<div>
<pre class="prettyprint linenums">pip list  #查看所有的python第三方包

pip freeze &gt; requirements.txt   #导出所有第三方包到 requirements.txt<br />
pip install -r requirements.txt    #安装这些包
 </pre>
</div>
<h4>②参数以及使用</h4>
<div>
<pre class="prettyprint linenums">#参数<br />
virtualenv     #虚拟环境<br />
name         #包名

ansible web -m pip -a "name=django==1.11.18"<br />
ansible web -m pip -a "name=flask"</pre>
</div>
<h3>9.service模块</h3>
<h4>①相关linux常用命令</h4>
<div>
<pre class="prettyprint linenums">ps -ef|grep redis   #查看redis进程

ss -tnlp    #查看端口信息

#启动服务,停止和重启分别为stop,restart<br />
systemctl start redis    #Centos7启动方式<br />
service redis start        #Centos6启动方式

#开机自启动<br />
systemctl enable redis   #Centos7启动方式<br />
chkconfig  redis on          #Centos6启动方式</pre>
</div>
<h4>②参数以及使用</h4>
<div>
<pre class="prettyprint linenums">enabled   #设置开机自启动<br />
name      #名称<br />
state       #状态<br />
    started<br />
    stopped<br />
    restarted    #重启<br />
    reload        #重新加载

ansible web -m service -a "name=redis state=strarted"  #开启远程机器redis<br />
ansible web -m service -a "name=redis state=stopped"  #关闭<br />
ansible web -m service -a "name=redis state=started enabled=yes"   #给远程机器设置开机自启redis</pre>
</div>
<h3>10.crontab模块</h3>
<p>crontab模块 ---&gt;定时任务</p>
<h4>①linux常用命令</h4>
<div>
<pre class="prettyprint linenums">crontab 用途:收集日志,备份数据,同步时间

* * * * * job<br />
分 时 日 月 周 任务<br />
0-59 0-23 1-31 1-12 0-7 job

1 * * * * job   #代表每个小时的第一分钟执行job<br />
2/ * * * * * job  #代表每隔2分钟执行job<br />
1 10-19 * * * job   #代表10到19点的第一分钟执行job<br />
#注意: 分钟不要用*，最好是指定时间

crontab -l   #查看计划任务<br />
crontab -r   # 删除所有计划任务<br />
crontab -e  #编辑计划任务</pre>
</div>
<h4>②参数以及使用</h4>
<div>
<pre class="prettyprint linenums">#注意 ansible中没有crontab  它表现的为cron模块 如下参数<br />
day<br />
huor<br />
job     #任务<br />
minute  #分钟<br />
month   #月<br />
name<br />
state   #状态<br />
user   #执行计划任务的用户<br />
weekday  #周<br />
disabled  #禁止

ansible web -m cron -a "minute=21 job='touch /tmp/cron.txt' name=touchfile" # 设置计划任务<br />
ansible web -m cron -a "minute=23 job='touch /tmp/cron.txt' name=touchfile4 disabled=yes" # 禁用计划任务，表现为加注释<br />
ansible web -m cron -a "name=touchfile4 state=absent" # 删除计划任务</pre>
</div>
<h3>11.user模块</h3>
<h4>①常用命令</h4>
<p>关于user,必须聊聊用户的分类</p>
<p>超级用户&nbsp; --- root&nbsp; &nbsp; &nbsp;uid :0</p>
<p>其他用户</p>
<ul><li>系统用户&nbsp; ---启动服务来专门设置的用户&nbsp; 1-999&nbsp; Centos7&nbsp; &nbsp; | 1-499 Centos6</li>
<li>登录用户&nbsp; ---普通的登录用户&nbsp; &nbsp;1000-65535&nbsp; Centos&nbsp; &nbsp; &nbsp;| 500-65535 Centos6</li></ul>
<div>
<pre class="prettyprint linenums">#useradd 命令参数<br />
 -d      # 指定家目录<br />
 -g      # 组id<br />
 -G, --groups GROUPS  # 附加组<br />
 -r, --system            # 创建系统用户<br />
 -s, --shell SHELL    # 登陆shell<br />
 -u, --uid UID      #用户id

useradd -s /sbin/nologin -u 2000 -d /opt/coco coco #创建用户,指定用户的登录shell为不登录, id 2000,家目录在/opt/coco<br />
useradd -s /sbin/nologin -G root,na  -d /opt/na na #指定附加组，最大的后面+1<br />
useradd -r feige # 创建系统用户，从999倒序<br />
userdel  feige # 删除用户<br />
userdel -r fei # 删除用户并删除用户的家目录 </pre>
</div>
<h4>②参数以及使用</h4>
<div>
<pre class="prettyprint linenums">#参数<br />
group   #组<br />
groups  #附件组<br />
home    #家目录<br />
name    #用户名<br />
password    #密码<br />
shell    #登录shell<br />
remove   #删除用户并且删除用户家目录<br />
state    #状态<br />
system  #系统用户<br />
uid        #用户id

ansible db -m user -a "name=dafei shell=/sbin/nologin home=/opt/dafei uid=2001 group=root"  #创建用户,指定用户家目录,登录shell情况,uid,组 

#解释: /sbin/nologin 作用<br />
指的是不允许login当前Linux系统。当用户配置成/sbin/nologin时，如果再使用该用户ssh到linux操作系统，会提示如下内容：This account is currently not available。该功能类似于封掉某个帐户。

ansible db -m user -a "name=dafei system=yes" #创建系统用户<br />
ansible db -m user -a "name=xiaofei state=absent"  #删除用户<br />
ansible db -m user -a "name=xiaofei state=absent remove=yes" #删除用户并且删除其家目录</pre>
</div>
<h3>12.group模块</h3>
<h4>①linux常用命令</h4>
<div>
<pre class="prettyprint linenums">#用户组的分类<br />
超级组   root                      uid 0<br />
其他组<br />
    系统组  uid  1-999 centos7  |  1-499 centos6<br />
    普通组  uid  1000-65535centos7   |  500-65535 centos6

-g    #指定组的id<br />
-r     #指定系统组

cat /etc/group    #查看所有组<br />
groupadd -g 3000 xiaofei  #创建一个组id为3000的组<br />
groupdel  xiaofei    #指定删除改组</pre>
</div>
<h4>②参数以及使用</h4>
<div>
<pre class="prettyprint linenums"># 常用参数<br />
gid    #组id<br />
name   #组名<br />
state    #状态<br />
system    #系统组

ansible db -m group -a "name=xiaoliu"    #创建普通组<br />
ansible db -m group -a  "name=xiaowang system=yes" #创建系统组<br />
ansible db -m group -a "name=xiaowang state=absent" #删除组</pre>
</div>
<div>
<div>
<pre class="prettyprint linenums">#web组操作

1 - 创建yuanyaun用户，指定用户的家目录为/opt/,指定用户的id为3000，指定用户的附加组为root<br />
2 - 创建tiantian用户组<br />
3 - 将本地的/etc/fstab 复制到远程，并指定属主是yuanyuan，属组是tiantian<br />
4 - 安装redis并启动，设置开机自启动<br />
5 - 安装django<br />
6 - 设置计划任务每天凌晨2点半备份/etc/目录，tar</pre>
</div>
<p>小小练习啦</p></div>
<div>
<div>
<pre class="prettyprint linenums">1. ansible web -m user -a "name=yuanyuan home=/opt/ uid=3000 groups=root"

2. ansible web -m user -a "name=tiantian"

3.ansible web -m copy -a "src=/etc/fstab dest=/etc/ owner=feige group=feige" 

4.ansible web -m yum -a "name=redis"<br />
  ansible web -m service -a "name=redis state=started enabled=yes"

5.absible web -m pip -a "name=django"

6. 30 2 * * *   tar -zvcf  alletc.tar.gz   /etc/*<br />
ansible web -m cron -a "minute=30 hour=2 job='tar a.tar.gz /etc/*' name=aaa"</pre>
</div>
<p>小小练习啦答案</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jev7e8.html">告别我的OI生涯</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzkpo9.html">AVD之PANIC&colon; Could not open</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gzkll8.html">使用yum时，保留下载包设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldp119.html">hbase伪分布式安装（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495owee8.html">td 自动换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ezzwz8.html">&lbrack;转载&rsqb;UEditor报错TypeError&colon; me&period;body is undefined</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyeekm9.html">GTA项目 三&comma; 使用 bootstrap table展示界面&comma;使得data和UI分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnmv0oq.html">ACM题目&mdash;&mdash;&mdash;&mdash;Subsequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok1mgx9.html">【转】iOS高级向的十道面试问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1op1j9.html">【spring 5】AOP：spring中对于AOP的的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn15o5k8.html">IOS做一个简单计算器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okgkel9.html">backbone collection add 事件回调参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdezpp09.html">oracle 外部表</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ogrx39.html">iOS设计模式之生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xrp709.html">javascript朝花夕拾</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm06gx9.html">print 函数的进一步理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpo2n39.html">转：KVC&sol;KVO原理详解及编程指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjwm1j8.html">memcache与mysql的连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m04vn8.html">linux服务器操作系统，在相同环境下，哪个做lamp服务器更稳定点？哪个版本更稳定？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z6yoj9.html">ASP&period;NET Core 入门教程 8、ASP&period;NET Core &plus; Entity Framework Core 数据访问入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93y5r2w8.html">Vue技术内幕  出去看看吧 挂载</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mo5w48.html">Django之BBS博客项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk1mo08.html">使用SSH的scp命令行传输文件到远程服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p1wdj8.html">linux服务器安装Mysql后，只能看到information&lowbar;schema&sol;test这两个库，无法修改密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzk4w48.html">easyui系列一 下拉框之组合框combobox</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eydvex9.html">【原创】大数据基础之Ambari（1）简介、编译安装、使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gelom48.html">SpringBoot配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eydz2e9.html">windows10 php7安装mongodb 扩展及其他扩展的思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1pzmdq.html">Zombie Scanning</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1keek69.html">LLDB 中从地址设置为变量</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
